import { createRoute } from "../../../modules/api-utils/createRoute";
import { unifiSites } from "../../../managers/unifiSites";
import { apiResponse } from "../../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../../middleware/authorization";

/* GET /v1/unifi/site/:id/overview */
export default createRoute(
  "get",
  ["/site/:id/overview"],
  async (c) => {
    const site = await unifiSites.fetch(c.req.param("id"));
    const overview = await unifiSites.getSiteOverview(site.siteId);
    const response = apiResponse.successful(
      "UniFi Site Overview Fetched Successfully!",
      overview,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({ permissions: ["unifi.access", "unifi.site.overview"] }),
);
